/***********************************
   Alumna: Cristina Iriarte Piqué
   Base de dades: Oracle 11g
   TFC: Control consum energètic
   Script: Funcions 
***********************************/

/*===========================================================================================
   FUNCIO: MISSATGE_ERROR
   DESCRIPCIÓ: RETORNA EL MISSATGE D'ERROR INDICAT A LA TAULA D'ERRORS MSG_ERRORS
               SEGONS L'ID DE L'ERROR INDICAT  
   PARAMETERS:
      INPUT: ME_ERROR
      OUTPUT: ME_DESC
   RETORNA: LA DESCRIPCIÓ DEL MISSATGE D'ERROR ENMAGATZEMAT A LA TAULA MSG_ERRORS 
   EXEMPLE DE CRIDA: MISSATGE_ERROR(ID_ERROR); 
===========================================================================================*/
CREATE OR REPLACE FUNCTION MISSATGE_ERROR (
    ME_ERROR IN MSG_ERRORS.ID_ERROR%TYPE)
    RETURN VARCHAR2
--    ME_ERROR IN MSG_ERRORS.ID_ERROR%TYPE,
--    ME_DESC  OUT MSG_ERRORS.DESCRIPCIO%TYPE) RETURN VARCHAR2
    AS
    ME_DESC MSG_ERRORS.DESCRIPCIO%TYPE;

    BEGIN
      -- CERCA EL MISSATGE D'ERROR A LA TAULA D'ERRORS MSG_ERRORS 
      SELECT DESCRIPCIO 
      INTO ME_DESC
      FROM MSG_ERRORS 
      WHERE ID_ERROR = ME_ERROR;
    
      RETURN(ME_DESC);
    
      EXCEPTION
        -- RETORNA BUIT EL MISSATGE SI NO EXISTEIX L'ERROR INDICAT 
        WHEN OTHERS THEN
 	      ME_DESC := '';
            RETURN(ME_DESC);

END MISSATGE_ERROR;
/
COMMIT;